"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  PAYLOAD_SYMBOL: true,
  REQUEST_SYMBOL: true
};
Object.defineProperty(exports, "PAYLOAD_SYMBOL", {
  enumerable: true,
  get: function get() {
    return _symbol.PAYLOAD_SYMBOL;
  }
});
Object.defineProperty(exports, "REQUEST_SYMBOL", {
  enumerable: true,
  get: function get() {
    return _symbol.REQUEST_SYMBOL;
  }
});
exports.default = void 0;

var _react = require("react");

var _plugin = _interopRequireDefault(require("./plugin"));

var _compose = _interopRequireWildcard(require("./compose"));

var _checker = _interopRequireWildcard(require("./checker"));

Object.keys(_checker).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _checker[key];
    }
  });
});

var _symbol = require("./symbol");

var _type = require("./type");

Object.keys(_type).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _type[key];
    }
  });
});

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useInit = function useInit(fn) {
  var ref = (0, _react.useRef)(true);

  if (ref.current) {
    ref.current = false;
    fn();
  }
}; // 请求中间件化


var createQuery = function createQuery(ctx, plugins) {
  return function (payload) {
    var meta = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    ctx[_symbol.PAYLOAD_SYMBOL] = payload;
    ctx.meta = meta;
    return (0, _compose.onionCompose)((0, _compose.timelineCompose)(ctx[_symbol.REQUEST_SYMBOL].timelines, plugins.middlewares || []))(ctx);
  };
};

var usePlugin = function usePlugin(pluginManagerContext) {
  var pluginManager = (0, _react.useMemo)(_plugin.default, []);
  useInit(function () {
    pluginManager.context.set(pluginManagerContext);
  }); // 每次执行都重新计算插件

  pluginManager.pureUse(pluginManagerContext.rawPlugins);
  var plugins = (0, _react.useMemo)(pluginManager.get, []);
  var pluginsProps = plugins.props.filter(function (prop) {
    return prop[_symbol.IS_NATIVE_SYMBOL];
  }).reverse().concat(plugins.props.reduce(function (acc, prop) {
    if (prop[_symbol.IS_NATIVE_SYMBOL]) {
      return acc;
    } else {
      return acc.concat((0, _checker.isFunction)(prop) ? prop(pluginManagerContext.app.ctx) : prop);
    }
  }, []));
  var props = (0, _compose.pipeMergedCompose)(pluginsProps);
  pluginManagerContext.plugins = plugins;
  pluginManagerContext.props = props;
  return pluginManagerContext;
};

var useQueryDisplay = function useQueryDisplay(request, rawPlugins) {
  var app = (0, _react.useMemo)(function () {
    return {
      query: function query() {
        return Promise.resolve();
      },
      ctx: _defineProperty({}, _symbol.REQUEST_SYMBOL, request),
      helper: _objectSpread(_objectSpread({}, _checker.default), _compose.default)
    };
  }, []);

  var _usePlugin = usePlugin({
    rawPlugins: rawPlugins,
    app: app
  }),
      props = _usePlugin.props,
      plugins = _usePlugin.plugins;

  var query = (0, _react.useMemo)(function () {
    return createQuery(app.ctx, plugins);
  }, [plugins, request]);
  app.query = query;
  app.ctx.query = query;
  return {
    props: props,
    plugins: plugins,
    query: query
  };
};

var _default = useQueryDisplay;
exports.default = _default;